#include <owl\applicat.h> 
#include <owl\decmdifr.h> 
#include <owl\editfile.h> 
#include <owl\mdi.h> 
#include <owl\controlb.h> 
#include <owl\statusba.h> 
#include <owl\buttonga.h> 
#include "pr46_1.rc"

// .
class TMDIApp: public TApplication
{
  public:
	 TMDIApp():TApplication(){}
	 void InitMainWindow();
  protected:
     TMDIClient *clienTWndw; 
     TControlBar *controlBar;
     void CmFileNew(); 
     void CmFileOpen();

     DECLARE_RESPONSE_TABLE (TMDIApp);
};

DEFINE_RESPONSE_TABLE1(TMDIApp, TApplication) 
    EV_COMMAND (CM_FILENEW, CmFileNew), 
    EV_COMMAND (CM_FILEOPEN, CmFileOpen),
END_RESPONSE_TABLE;

// TMDIApp::InitMainWindow()
//      ,
// -,    
//  .
void TMDIApp::InitMainWindow()
{
  //  -.
  clienTWndw = new TMDIClient;
  //   . 
  TDecoratedMDIFrame *frameWnd = new TDecoratedMDIFrame (" ",
			 MENU_1, *clienTWndw, TRUE);
  //      .
  frameWnd->Attr.X = 50;
  frameWnd->Attr.Y = 50;
  frameWnd->Attr.W = 500;
  frameWnd->Attr.H = 300;
  //   . 
  controlBar = new TControlBar (frameWnd); 
  controlBar->Insert(*new TButtonGadget(ID_NEW, CM_FILENEW));
  controlBar->Insert(*new TButtonGadget(ID_OPEN, CM_FILEOPEN));
  controlBar->Insert(*new TButtonGadget(ID_SAVE, CM_FILESAVE));
  controlBar->Insert(*new TSeparatorGadget (10));
  controlBar->Insert(*new TButtonGadget(ID_CUT, CM_EDITCUT));
  controlBar->Insert(*new TButtonGadget(ID_COPY, CM_EDITCOPY));
  controlBar->Insert(*new TButtonGadget(ID_PASTE, CM_EDITPASTE));
  controlBar->Insert(*new TButtonGadget(ID_UNDO, CM_EDITUNDO));
  //   ,  
  //  .
  controlBar->SetHintMode(TGadgetWindow::EnterHints);
  //      . 
  frameWnd->Insert(*controlBar, TDecoratedFrame::Top);
  //   .
  TStatusBar *statusBar = new TStatusBar (0,
     TGadget::Recessed,
     TStatusBar::CapsLock | TStatusBar::NumLock |
     TStatusBar::Overtype);
  //      . 
  frameWnd->Insert(*statusBar, TDecoratedFrame::Bottom);
  //     . 
  frameWnd->SetIcon (this, ID_MDIEDIT);
  //     Microsoft. 
  EnableCtl3d (TRUE);
  //    MainWindow .
  SetMainWindow(frameWnd);
}

// TMDIApp::CmFileNew()
//     ,  
//   New   File  
//    New   . 
void TMDIApp::CmFileNew()
{
  //    
  //  .
  TEditFile *editFile = new TEditFile;
  //      .
  TMDIChild *childWnd = new TMDIChild (*clienTWndw, "", editFile);
  //   .
  childWnd->SetIcon(this,ID_DOCUMENT);
  //    .
  childWnd->Create();
}

// TMDIApp::CmFileOpen()
//     ,  
//   Open   File  
//    Open   . 
void TMDIApp::CmFileOpen()
{
  //   TData  .
  TOpenSaveDialog::TData fileData (OFN_FILEMUSTEXIST | 
    OFN_HIDEREADONLY | OFN_PATHMUSTEXIST,
	 "  (*.*) | *.* |  (*.txt) | *.txt |", 0, 0, " * ");
  //      . 
  strcpy(fileData.FileName, "");
  //    Open. 
  TFileOpenDialog *dialog =
            new TFileOpenDialog (MainWindow, fileData);
  //    Open. 
  int result = dialog->Execute();
  //      ...
  if (result == IDOK)
  {
    //     
    //  . 
    TEditFile *editFile =
           new TEditFile (0, 0, 0, 0, 0, 0, 0, fileData.FileName);
    //      . 
    TMDIChild *childWnd =
			 new TMDIChild (*clienTWndw, "", editFile);
    //   . 
    childWnd->SetIcon (this, ID_DOCUMENT);
    //    . 
    childWnd->Create();
  }
  //    . 
  controlBar->SetHintCommand (-1);
}

int OwlMain(int,char *[])
{
  return TMDIApp().Run();
}
